#include "controls.h"

control_point make_control_point(long x, long y, unsigned char on_curve) {
  control_point cp;
  
  cp.pos = make_point(x, y);
  cp.on_curve = on_curve;
  cp.next = NULL;
  
  return cp;
}

void draw_control_points(SDL_Surface *screen, control_point *points, Uint32 color) {
  control_point *cp = points;
  
  while(cp != NULL) {
    show_rect(screen, point_x(cp->pos) - CP_DIAM, point_y(cp->pos) - CP_DIAM, 2 * CP_DIAM + 1, 2 * CP_DIAM + 1, color);
    
    cp = cp->next;
    if(cp == points)
      break;
  }
}

control_point *hit_test(control_point *points, long x, long y) {
  control_point *cp = points;
  
  while(cp != NULL) {
    if(x >= point_x(cp->pos) - CP_DIAM && x <= point_x(cp->pos) + CP_DIAM && 
       y >= point_y(cp->pos) - CP_DIAM && y <= point_y(cp->pos) + CP_DIAM)
      return cp;
    
    cp = cp->next;
    if(cp == points)
      break;
  }

  return NULL;
}
